#define DATUMLEFT 0
#define WAVEOFFLEFT 1
#define CUTLEFT 2
#define CUTRIGHT 3
#define WAVEOFFRIGHT 4
#define DATUMRIGHT 5
#define BALL0 6
#define BALL1 7
#define BALL2 8
#define BALL3 9
#define BALL4 10

#define OFF "#(argb,8,8,3)color(0.501961,0.501961,0.501961,1.0,CO)"
#define ACTIVE "#(argb,8,8,3)color(1,0.501961,0.25098,1.0,CO)"
#define STANDBY "#(argb,8,8,3)color(1,1,0,1.0,CO)"
#define RED "#(argb,8,8,3)color(1,0,0,1.0,CO)"
#define GREEN "#(argb,8,8,3)color(0,1,0,1.0,CO)"

#define WAVEOFFDIST 400

ttt_fnc_waveoff = {
	params ["_deck8"];
	_deck8 setObjectTextureGlobal [WAVEOFFLEFT, RED];
	_deck8 setObjectTextureGlobal [WAVEOFFRIGHT, RED];
	sleep 0.025;
	_deck8 setObjectTextureGlobal [WAVEOFFLEFT, OFF];
	_deck8 setObjectTextureGlobal [WAVEOFFRIGHT, OFF];
};

ttt_fnc_iflolsPic = {
	params ["_plane"];

	_plane setVariable ['ttt_iflolsActive', true];

	private _deck8 = ["JDG_carrier_deck_8"] call TTT_fnc_global;
	/*private _deck8 = _carrier getVariable "JDG_carrier_deck_8";*/
	private _carrier = _deck8 getVariable "TTT_NimitzParent";

	_deck8 setObjectTextureGlobal [WAVEOFFRIGHT, OFF];
	_deck8 setObjectTextureGlobal [WAVEOFFLEFT, OFF];
	_deck8 setObjectTextureGlobal [CUTLEFT, OFF];
	_deck8 setObjectTextureGlobal [CUTRIGHT, OFF];
	{
		_deck8 setObjectMaterialGlobal [_x, "\jdg_carrier\data\iflols\light.rvmat" ];
	} forEach [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];


	// Example taken from https://community.bistudio.com/wiki/setPiPEffect
	private _iflols = _deck8 modelToWorld (_deck8 selectionPosition "IFLOLS");
	private _camPos = _iflols getPos [5, (getDir _carrier) + 175];
	_campos = [_camPos select 0, _camPos select 1, 19];
	private _cam = "camera" camCreate _camPos;
	_cam camSetTarget _iflols;
	_cam camCommit 0;
	_cam cameraEffect ["internal","back","rtt"];
	with uiNamespace do {
		if (!isNil "ttt_nimitz_iflols") then {
			ctrlDelete ttt_nimitz_iflols;
		};
		while {isNull (findDisplay 46)} do {
			sleep 0.1;
		};
	    ttt_nimitz_iflols = findDisplay 46 ctrlCreate ["RscPicture", -1];
	    ttt_nimitz_iflols ctrlSetPosition [safeZoneX, ( safeZoneY + safeZoneH ) - 0.8, 0.5, 0.5];
	    ttt_nimitz_iflols ctrlCommit 0;
	    ttt_nimitz_iflols ctrlSetText "#(argb,512,512,1)r2t(rtt,1.0)";
	};

	// Copy of fn_iflolsCalc.sqf, modified

	private _jdgNimArrestor = _carrier getVariable "jdgNimArrestor";
	private _distanceB = _plane distance _jdgNimArrestor;

	while {(_plane distance _jdgNimArrestor) > 50} do
	{
		private _distanceA = _plane distance _jdgNimArrestor;
		private _planeAlt = getPosASL _plane select 2;
		private _jdgNimArrestorAlt = getPosASL _jdgNimArrestor select 2;
		private _angle = ((_planeAlt - _jdgNimArrestorAlt) / (_plane distance _jdgNimArrestor)); // calculate angle of plane to touchdown
		// switch: make proper ball active
		switch (true) do
		{
			case (_angle > 0.096): {
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL3, BALL4];
				// flash wave off lights in red when close to the carrier
				if (_distanceA  < WAVEOFFDIST) then {
					[_deck8] spawn ttt_fnc_waveoff;
				};

			};  //5.5 degrees
			case (_angle > 0.088): {
				_deck8 setObjectTextureGlobal [BALL4, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL3];
		    };
			case (_angle > 0.083): {
				_deck8 setObjectTextureGlobal [BALL4, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL3];
			};
			case (_angle > 0.078): {
				_deck8 setObjectTextureGlobal [BALL3, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL4];
			}; //4.5 degrees
			case (_angle > 0.072): {
				_deck8 setObjectTextureGlobal [BALL3, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL4];
			};
			case (_angle > 0.067): {
				_deck8 setObjectTextureGlobal [BALL2, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL3, BALL4];
			};
			case (_angle > 0.061): {
				_deck8 setObjectTextureGlobal [BALL2, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL3, BALL4];
			}; //3.5 degrees
			case (_angle > 0.056): {
				_deck8 setObjectTextureGlobal [BALL1, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL2, BALL3, BALL4];
			};
			case (_angle > 0.050): {
				_deck8 setObjectTextureGlobal [BALL1, ACTIVE];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL2, BALL3, BALL4];
			};
			case (_angle > 0.044): {
				_deck8 setObjectTextureGlobal [BALL0, RED];
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL1, BALL2, BALL3, BALL4];
			}; //1.5 degrees
			case (_angle <= 0.044): {
				{
					_deck8 setObjectTextureGlobal [_x, OFF];
				} forEach [BALL0, BALL1, BALL2, BALL3, BALL4];
				// flash wave off lights in red when close to carrier
				if (_distanceA  < WAVEOFFDIST) then {
					[_deck8] spawn ttt_fnc_waveoff;
				};
			};
		};
		private _distanceB = _plane distance _jdgNimArrestor;
		sleep 0.05;
		if ((_distanceA - _distanceB) > 0) exitWith {
			_plane setVariable ['ttt_iflolsActive', false];
			// turn off meat ball and datum lights
			{
				_deck8 setObjectTextureGlobal [_x, OFF];
			} forEach [BALL0, BALL1, BALL2, BALL3, BALL4, DATUMLEFT, DATUMRIGHT];
			// flash wave off lights in red
			{
				_deck8 setObjectTextureGlobal [WAVEOFFLEFT, RED];
				_deck8 setObjectTextureGlobal [WAVEOFFRIGHT, RED];
				sleep 0.1;
				_deck8 setObjectTextureGlobal [WAVEOFFLEFT, OFF];
				_deck8 setObjectTextureGlobal [WAVEOFFRIGHT, OFF];
				sleep 0.1;
			} forEach [0, 1, 2, 3, 4, 5];
			with uiNamespace do {
				if (!isNil "ttt_nimitz_iflols") then {
					ctrlDelete ttt_nimitz_iflols;
				};
			};
			// reset datum lights
			{
				_deck8 setObjectTextureGlobal [_x, GREEN];
			} forEach [DATUMLEFT, DATUMRIGHT];
		}; //exit script, moving away from carrier
	};
	with uiNamespace do {
		if (!isNil "ttt_nimitz_iflols") then {
			ctrlDelete ttt_nimitz_iflols;
		};
	};
	_plane setVariable ['ttt_iflolsActive', false];
	// Somehow need to set the correct lights for a successfull landing
	{
		_deck8 setObjectTextureGlobal [_x, OFF];
	} forEach [BALL0, BALL1, BALL2, BALL3, BALL4];

	_deck8 setObjectTextureGlobal [CUTLEFT, GREEN];
	_deck8 setObjectTextureGlobal [CUTRIGHT, GREEN];

/**
	_cutlight = 0;
	while {((_jet distance _jdgNimArrestor) > 25) and (_cutlight == 0)} do
	{
		_distanceA = _jet distance _jdgNimArrestor;
		if ((_distanceA - _distanceB) > 0) exitWith {};

		_jet_Alt = (getPosASL _jet select 2);
		_jdgNimArrestor_Alt = (getPosASL _jdgNimArrestor select 2);
		_angle = ((_jet_Alt - _jdgNimArrestor_Alt) / (_jet distance _jdgNimArrestor));

		//switch: acceptable angle range increased when closer to prevent incorrect image readings on OK landing slopes
		switch (true) do
		{
			case ((_angle > 0.056) && (_angle < 0.067) && ((_jet distance _jdgNimArrestor) < 150)): {TitleRsc ["IFLOLS_cut", "PLAIN DOWN", 0]; _cutLight = 1;}; //cut lights on, good landing, exit script
			case (_angle > 0.093): {TitleRsc ["IFLOLS_6_wave", "PLAIN DOWN", 0];};
			case (_angle > 0.088): {TitleRsc ["IFLOLS_6", "PLAIN DOWN", 0];};
			case (_angle > 0.083): {TitleRsc ["IFLOLS_5", "PLAIN DOWN", 0];};
			case (_angle > 0.078): {TitleRsc ["IFLOLS_4", "PLAIN DOWN", 0];};
			case (_angle > 0.072): {TitleRsc ["IFLOLS_3", "PLAIN DOWN", 0];};
			case (_angle > 0.067): {TitleRsc ["IFLOLS_2", "PLAIN DOWN", 0];};
			case (_angle > 0.061): {TitleRsc ["IFLOLS_1", "PLAIN DOWN", 0];}; //3.5 degrees
			case (_angle > 0.056): {TitleRsc ["IFLOLS_7", "PLAIN DOWN", 0];};
			case (_angle > 0.050): {TitleRsc ["IFLOLS_8", "PLAIN DOWN", 0];};
			case (_angle > 0.044): {TitleRsc ["IFLOLS_9", "PLAIN DOWN", 0];};
			case (_angle < 0.044): {TitleRsc ["IFLOLS_9_wave", "PLAIN DOWN", 0];};
		};
		_distanceB = _jet distance _jdgNimArrestor;
		// if (_cutlight == 1) exitWith {};
		sleep 0.05;
	};

**/


/*	{
		_deck8 setObjectTextureGlobal [_x, "#(argb,8,8,3)color(0,1,0,1.0,CO)"];
		_deck8 setObjectMaterialGlobal [_x, "\jdg_carrier\data\iflols\red.rvmat" ];
	} forEach [0, 1, 2, 3, 4, 5];

	sleep 10;
	f setPilotCameraTarget (_deck8 modelToWorld (_deck8 selectionPosition "IFLOLS"));
	{
		_deck8 setObjectTextureGlobal [_x, "#(argb,8,8,3)color(0,0,1,1.0,CO)"];
		_deck8 setObjectMaterialGlobal [_x, "\jdg_carrier\data\iflols\blue.rvmat" ];
	} forEach [0, 1, 2, 3, 4, 5];
*/
};

/*[N, plane] spawn ttt_fnc_iflolsPic;*/

private _activate = format [
	"(!(_target getVariable ['ttt_iflolsActive', false]))
	and ((getPosASL _target) select 2 < 250)
	and ((_target distance %1) > 200)
	and ((_target distance %1) < 3500)
	and (%1 getRelDir _target < 182)
	and (%1 getRelDir _target > 164)",
	"([""nimspots""] call TTT_fnc_global)"];

_msg = "IFLOLS Picture" call TTT_fnc_colAct;
plane addAction[_msg, TTT_fnc_iflolsPic,
	[], 2, false, true, "",
	_activate];

